#!/usr/bin/env python3

'''Decrypt the Q-GUID in login.login WUP requests (in other WUP requests the
Q-GUID is typically not individually encrypted.
'''

import sys

from Crypto.Cipher import DES3

KEY = b'c\xd7\x90c<\x0e/\xc3F\xef\x857B\x1f\x9dJF=X\xf3\x8a\x95\xec\x84'

def main():
    cipher = DES3.new(KEY, DES3.MODE_ECB)
    crypto = sys.stdin.buffer.read()
    plain = cipher.decrypt(crypto)
    padding = plain[-1]
    if 0 < padding <= 8 and all(b == padding for b in plain[-padding:]):
        plain = plain[:-padding]
    else:
        sys.stderr.write('Warning: invalid padding\n')
    sys.stdout.buffer.write(plain)

if __name__ == '__main__':
    main()
