#!/usr/bin/env python3

'''Decrypt nested WUP payload.'''

import sys

from Crypto.Cipher import DES

KEY = b'b\xe89\xac\x8du7y'

def main():
    cipher = DES.new(KEY, DES.MODE_ECB)
    crypto = sys.stdin.buffer.read()
    plain = cipher.decrypt(crypto)
    padding = plain[-1]
    if 0 < padding <= 8 and all(b == padding for b in plain[-padding:]):
        plain = plain[:-padding]
    else:
        sys.stderr.write('Warning: invalid padding\n')
    sys.stdout.buffer.write(plain)

if __name__ == '__main__':
    main()
